/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao;

import java.io.Serializable;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * iモード端末の背面画面情報を提供します。
 * 
 * @author 杉澤 浩二
 */
public class ImodeSubscreen implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * デフォルトコンストラクタです。
	 */
	public ImodeSubscreen() {}

	/**
	 * 機種名を保持します。
	 */
	private String name;

	/**
	 * 機種名を返します。
	 * 
	 * @return 機種名
	 */
	public String getName() {
		return name;
	}

	/**
	 * 機種名を設定します。
	 * 
	 * @param name 機種名
	 */
	public void setName(final String name) {
		this.name = StringUtils.defaultIfEmpty(name, null);
	}

	/**
	 * 待受け画面の幅(ピクセル)を保持します。
	 */
	private Integer width;

	/**
	 * 待受け画面の幅(ピクセル)を返します。
	 * 
	 * @return 待受け画面の幅(ピクセル)
	 */
	public Integer getWidth() {
		return width;
	}

	/**
	 * 待受け画面の幅(ピクセル)を設定します。
	 * 
	 * @param width 待受け画面の幅(ピクセル)
	 */
	public void setWidth(final Integer width) {
		if (width == null || width <= 0)
			this.width = null;
		else
			this.width = width;
	}

	/**
	 * 待受け画面の高さ(ピクセル)を保持します。
	 */
	private Integer height;

	/**
	 * 待受け画面の高さ(ピクセル)を返します。
	 * 
	 * @return 待受け画面の高さ(ピクセル)
	 */
	public Integer getHeight() {
		return height;
	}

	/**
	 * 待受け画面の高さ(ピクセル)を設定します。
	 * 
	 * @param height 待受け画面の高さ(ピクセル)
	 */
	public void setHeight(final Integer height) {
		if (height == null || height <= 0)
			this.height = null;
		else
			this.height = height;
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public boolean equals(final Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
